/****************************************
Filename: libVideotester/VtUtils.h
Description: misc utils for Videotester
Author: Christian Linhart
Copyright: (C)1997-2011 Christian Linhart
****************************************/


/* this include must be outside of the #ifndef bracket because of the include of Layer1.h inside DRError.h */
#include "DRError.h"

#ifndef VtUtils_h
#define VtUtils_h

#include <stdarg.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>
#ifdef SVR4
#include <sys/statvfs.h>
#elif defined(sun)
#include <sys/vfs.h>
#else
#include <sys/statfs.h>
#endif
#include <sys/stat.h>



#include <X11/Xproto.h>



#include <X11/Xlib.h>

#include <X11/Xfuncproto.h>
_XFUNCPROTOBEGIN


#ifndef VTINC_global_no_clientlibs
/* Compare the RGB-Values of two X-Colors.
 Return True if they are equal */
Bool VtUtils_EqualXColorRGB(
    const XColor *color1, const XColor *color2);
    
/* init a color with all zeroes */
void VtUtils_InitXColor( XColor *color );

/* Convert XColor to xColorItem */
xColorItem VtUtils_XColor_to_xColorItem(
    const XColor *color);
/* Convert  xColorItem to XColor */
XColor VtUtils_xColorItem_to_XColor(
    const xColorItem *citem);
#endif

/* Substitute for strdup which sets the error-code
   appropriately */
char* VtUtils_strdup(const char* s, VtError *err);


_XFUNCPROTOEND

#endif
