/****************************************
Filename: error.c
Description: Error handling
Author: Christian Linhart
Copyright: (C)1997-2011 Christian Linhart
****************************************/


#include <stdlib.h>
#include "DRMem.h"
#include "DRError.h"

void VtError_DeleteErrorData(VtError err)
{
    switch(err->type) {

    case VtError_L1WriteError: { 
	/* do nothing */
    } break;

    case VtError_L1ReadError: { 
	/* do nothing */
    } break;

    case VtError_NoError: { 
	/* do nothing */
    } break;

    case VtError_OutOfMemory: { 
	/* do nothing */
    } break;

    case VtError_BaseServerOutOfMemory: { 
	/* do nothing */
    } break;

    case VtError_RpservOutOfMemory: { 
	/* do nothing */
    } break;

    case VtError_CantOpenFileForReading_CLASS: 
    case VtError_CantOpenFileForWriting_CLASS:
    { 
	if ( err->data.file_open.filename != NULL ) {
	    DELETEARRAY(err->data.file_open.filename);
	    err->data.file_open.filename = NULL;
	}
    } break;

    case VtError_CantOpenDir_CLASS:
    {
	if ( err->data.dir_open.dirname != NULL ) {
	    DELETEARRAY(err->data.dir_open.dirname);
	    err->data.dir_open.dirname = NULL;
	}
    } break;

    case VtError_CantCloseFileForReading_CLASS: 
    case VtError_CantCloseFileForWriting_CLASS:
    {
	if ( err->data.file_close.filename != NULL ) {
	    DELETEARRAY(err->data.file_close.filename);
	    err->data.file_close.filename = NULL;
	}
    } break;
    
    case VtError_CantRenameFile_CLASS:
    {
	if ( err->data.file_rename.oldpath != NULL ) {
	    DELETEARRAY(err->data.file_rename.oldpath);
	    err->data.file_rename.oldpath = NULL;
	}
	if ( err->data.file_rename.newpath != NULL ) {
	    DELETEARRAY(err->data.file_rename.newpath);
	    err->data.file_rename.newpath = NULL;
	}
    } break;

    case VtError_DupFailed_CLASS:
    {
	/* nothing to clean up */
    } break;

    case VtError_CantReadSymlink_CLASS:
    {
	if ( err->data.readlink.path != NULL ) {
	    DELETEARRAY(err->data.readlink.path);
	    err->data.readlink.path = NULL;
	}
    } break;

    } /* end switch */
}


