/****************************************
Filename: mem.c
Description: Memory management
Author: Christian Linhart
Copyright: (C)1998 Christian Linhart
****************************************/

#include "DRMem.h"


#include <X11/Xlib.h>


static VtErrorRec Vtmem_error;

void* Vtmem_alloc(size_t size, VtError *err)
{
    void *ptr;
    if (size == 0) size=1; /* some mallocs don't want size==0 */
    ptr = malloc(size);
    if (ptr == NULL) {
	/* Out of memory --> set error code */
	Vtmem_SetOutOfMemError( err );
    }
    return ptr;
}

/* set out of memory error */
void Vtmem_SetOutOfMemError( VtError *err )
{
    DELERR;
    Vtmem_error.type = VtError_OutOfMemory;
    Vtmem_error.free_on_delete = False;
    *err = &Vtmem_error;
}
