/****************************************
Filename: libVideotester/VtUtils.c
Description: misc utils for Videotester
Author: Christian Linhart
Copyright: (C)1997-2011 Christian Linhart
****************************************/


#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <fcntl.h>
#include <errno.h>
#include <libgen.h>
#include <ctype.h>
#include <stdarg.h>
#include "VtUtils.h"
#include <string.h>
#include "DispRec/DRMem.h"
#include <X11/Xproto.h>
#include <X11/Xlib.h>
#include <signal.h>


/* Convert XColor to xColorItem */
xColorItem VtUtils_XColor_to_xColorItem(
    const XColor *color)
{
    xColorItem citem;
    citem.pixel = color->pixel;
    citem.red = color->red;
    citem.green = color->green;
    citem.blue = color->blue;
    citem.flags = color->flags;
    return citem;
}

/* Convert  xColorItem to XColor */
XColor VtUtils_xColorItem_to_XColor(
    const xColorItem *citem)
{
    XColor color;
    color.pixel = citem->pixel;
    color.red = citem->red;
    color.green = citem->green;
    color.blue = citem->blue;
    color.flags = citem->flags;
    return color;
}


/* Substitute for strdup which sets the error-code
   appropriately */
char* VtUtils_strdup(const char* s, VtError *err)
{
#define ERR_RETVAL ((char*)NULL)
    if ( s == NULL ) {
	return NULL;
    } else {
	int len=strlen(s);
	char* sdup = NEWARRAY(char, len+1);
	RETVALONERR;
	strcpy(sdup, s);
	return sdup;
    }
#undef ERR_RETVAL
}





