
#include <X11/Xlib.h>
#include "DispRec/DispRecCtrlExtension.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>


int main(int argc, char* argv[])
{
    Display* dpy;
    Bool haveDispRecCtrl=False;
    int event_base, error_base;
    int argIdx;
    unsigned long flags = 0;
    
    /* parse commandline */
    for( argIdx = 1; argIdx < argc; argIdx++ ) {
	const char* arg = argv[argIdx];
	if ( strcmp(arg, "-a") == 0 ) {
		/* only active recordings */
		flags |= XDispRecCtrl_ListRecordingSessions_Flag_Active;
	}
    }
    
    printf("flags=%lu\n", flags);

    dpy=XOpenDisplay(NULL);

    if ( dpy == NULL ) {
	fprintf(stderr, "error: Could not open the display.\n");
	exit(1);
    }
    
    haveDispRecCtrl = 
	XDispRecCtrl_QueryExtension(
    	dpy, &event_base, &error_base);

    printf("haveDispRecCtrl=%d\n", haveDispRecCtrl);
    if (haveDispRecCtrl) {
	int count = 0;
	int idx = 0;
	/* query */
	DispRecCtrl_RecordingSession* recordingSessions =
		XDispRecCtrl_ListRecordingSessions(
			dpy, flags, &count
		);
	/* output */
	printf("got the following %d sessions:\n", count);
	for( idx = 0; idx < count; idx ++ ) {
		printf( "%d\n", (int)(recordingSessions[idx]) );
	}
	/* clean up */
	XFree( recordingSessions );
    }
    fflush(stdout);
    exit(0);
}


