#tcl script

########################################################
# DemoRecorder Launchpad
#
# Copyright (C) 2009 Christian Linhart <chris@DemoRecorder.com>
########################################################

package require drWidgetFileSelection 1.0

#*** GUI ***
frame .t

set explainTextWidth "300p"
set labelTextWidth "150p"

#Headline
label .t.hello -text "DemoRecorder V"

grid configure .t.hello -in .t

frame .t.top 

set rowCount 0
 
 
proc identity { x } {
	return $x
}

ttk::style configure EvenStyle.TRadiobutton -background #999999
ttk::style map EvenStyle.TRadiobutton -background  [ list disabled #999999 active #FF9999 ]

ttk::style configure OddStyle.TRadiobutton -background  #BBBBBB 
ttk::style map OddStyle.TRadiobutton -background  [ list disabled #BBBBBB active #FFBBBB ] 

#ttk::style configure TRadiobutton -background #FF0000

proc getStyle { widget } {
	global rowCount
	
	if { ( $rowCount % 2 ) == 0 } { 
		return EvenStyle.$widget;
	} else { 
		return OddStyle.$widget;
	}	
}

proc getStyleOpt { widget } {
	return [ list -style [ getStyle $widget ] ]
}

set leftColumns ""

proc configButtonAndLabel { parent name buttonLabel text command } {
	global explainTextWidth
	global rowCount
	global leftColumns

	button ${parent}.${name}Button -text $buttonLabel -font "-size 20" -command $command  
	label ${parent}.${name}Label -text $text \
		-state normal \
		-font "-size 10" \
		-wraplength $explainTextWidth \
		-justify left \
		-background [ if { ( $rowCount % 2 ) == 0 } { identity #9999DD } else { identity #BBBBFF } ] \
		-anchor w
	eval [ concat grid configure ${leftColumns} ${parent}.${name}Button ${parent}.${name}Label -in ${parent} ]
	grid configure ${parent}.${name}Button -sticky ew 
	grid configure ${parent}.${name}Label -sticky ewns -pady 1
	set rowCount [ expr $rowCount + 1 ]
}

proc configButtonAndLabel3 { parent name buttonLabel text command } {
	global explainTextWidth
	global rowCount
	global leftColumns

	#label ${parent}.${name}Label -text ""
	button ${parent}.${name}Button -text $buttonLabel -font "-size 20" -command $command  
	label ${parent}.${name}ExplainLabel -text $text \
		-state normal \
		-font "-size 10" \
		-wraplength $explainTextWidth \
		-justify left \
		-background [ if { ( $rowCount % 2 ) == 0 } { identity #9999DD } else { identity #BBBBFF } ] \
		-anchor w
	eval [ concat grid configure ${leftColumns} ${parent}.${name}Button - ${parent}.${name}ExplainLabel -in ${parent} ]
	grid configure ${parent}.${name}Button -sticky ew 
	grid configure ${parent}.${name}ExplainLabel -sticky ewns -pady 1
	set rowCount [ expr $rowCount + 1 ]
}

proc configComboBoxAndLabel3 { parent name label text var values } {
	global explainTextWidth
	global rowCount
	global labelTextWidth
	global $var
	global leftColumns

	label ${parent}.${name}Label -text $label \
		-state normal \
		-font "-size 10" \
		-wraplength $labelTextWidth \
		-justify left \
		-anchor w
	ttk::combobox ${parent}.${name}Combobox -values $values -font "-size 10" -textvariable $var  
	label ${parent}.${name}ExplainLabel -text $text \
		-state normal \
		-font "-size 10" \
		-wraplength $explainTextWidth \
		-justify left \
		-background [ if { ( $rowCount % 2 ) == 0 } { identity #9999DD } else { identity #BBBBFF } ] \
		-anchor w
	eval [ concat grid configure ${leftColumns} ${parent}.${name}Label ${parent}.${name}Combobox ${parent}.${name}ExplainLabel -in ${parent} ]
	grid configure ${parent}.${name}Combobox -sticky ew 
	grid configure ${parent}.${name}ExplainLabel -sticky ewns -pady 1
	grid configure ${parent}.${name}Label -sticky ewns -pady 1
	set rowCount [ expr $rowCount + 1 ]
}

proc configRadioButtonSet3 { parent name label text var values  } {
	global explainTextWidth
	global rowCount
	global labelTextWidth
	global $var 
	global leftColumns

	label ${parent}.${name}Label -text $label \
		-state normal \
		-font "-size 10" \
		-wraplength $labelTextWidth \
		-justify left \
		-anchor w
		
	set first 1
	
	foreach option $values {
		lassign $option value active buttonLabel explainText
		
			
		frame ${parent}.${name}RadioButtonFrame${value} \
			-background [ if { ( $rowCount % 2 ) == 0 } { identity #999999 } else { identity #BBBBBB } ]

		ttk::radiobutton ${parent}.${name}RadioButton${value} \
			-text $buttonLabel \
			-variable $var \
			-value $value \
			-state [ if { $active != 0 } { identity "normal" } else { identity "disabled" } ] \
			{*}[ getStyleOpt TRadiobutton ]
			
		
		#set style [ ${parent}.${name}RadioButton${value} cget -style ]
		set style [ winfo class ${parent}.${name}RadioButton${value} ]
		puts stdout "style=$style" 
			
		label ${parent}.${name}ExplainLabel${value} -text $explainText \
			-state normal \
			-font "-size 10" \
			-wraplength $explainTextWidth \
			-justify left \
			-background [ if { ( $rowCount % 2 ) == 0 } { identity #9999DD } else { identity #BBBBFF } ] \
			-anchor w
			
		eval [ concat grid configure \
			${leftColumns} \
			[ \
				if { $first == 1 } {
					identity "${parent}.${name}Label";
				} else {
					identity "^";
				} \
			] \
			${parent}.${name}RadioButton${value} \
			${parent}.${name}ExplainLabel${value} -in ${parent} \
		]
			 
		grid configure ${parent}.${name}RadioButton${value} -sticky ewns -pady 1
		grid configure ${parent}.${name}ExplainLabel${value} -sticky ewns -pady 1
		if { $first == 1 } {
			grid configure ${parent}.${name}Label -sticky ewns -pady 1
		}
			
		if { $first == 1 } { set first 0 }
		
		set rowCount [ expr $rowCount + 1 ]
	}

}

proc configStartSection3 { parent name headline margintext explainText  } {
	global leftColumns
	global explainTextWidth
	global rowCount
	
	label ${parent}.${name}Headline -text $headline \
		-state normal \
		-font "-size 10" \
		-justify left \
		-anchor w \
		-background #88FF88

	label ${parent}.${name}Margin -text $margintext \
		-state normal \
		-font "-size 10" \
		-justify left \
		-anchor w \
		-background #88FF88
		
	label ${parent}.${name}ExplainLabel -text $explainText \
		-state normal \
		-font "-size 10" \
		-wraplength $explainTextWidth \
		-justify left \
		-background #66DD66\
		-anchor w

	eval [ concat grid configure ${leftColumns} ${parent}.${name}Margin ${parent}.${name}Headline - ${parent}.${name}ExplainLabel -in ${parent} ]
	grid configure ${parent}.${name}Headline -sticky ewns -pady 1
	grid configure ${parent}.${name}Margin -sticky ewns -pady 1
	grid configure ${parent}.${name}ExplainLabel -sticky ewns -pady 1
	
	lappend leftColumns "^"	
}

proc configEndSection3 { parent name } {
	global leftColumns

	puts stdout "before remove last: leftColumns = $leftColumns"

	#remove last element of leftColumns
	set leftColumns [ lreplace leftColumns end end ]
		
	puts stdout "after remove last: leftColumns = $leftColumns"

	label ${parent}.${name}Footer -text "" \
		-state normal \
		-font "-size 5" \
		-justify left \
		-anchor w \
		-background #BB8866

	eval [ concat grid configure ${leftColumns} ${parent}.${name}Footer - - - -in ${parent} ]
	grid configure ${parent}.${name}Footer -sticky ewns -pady 1
	
}


configButtonAndLabel .t.top "record" "Record" \
	"Press this button to open the recording dialog" \
	{
		grid forget .t.top
		grid configure .t.rec -in .t
	}

configButtonAndLabel .t.top "export" "Export" \
	"Press this button to export a demorecorder video to some common file format such as AVI, FLV, MPEG 1/2/4, ..." \
	{
		puts  "starting $env(DEMOREC_DIR)/bin/demorec-exporter"
		exec "$env(DEMOREC_DIR)/bin/demorec-exporter" &
	}

configButtonAndLabel .t.top "play" "Play" \
	"Press this button to play a demorecorder video" \
	{
	}

configButtonAndLabel .t.top "preferences" "Preferences" \
	"Press this button to change preferences and config of DemoRecorder" \
	{
	}

configButtonAndLabel .t.top "licenseManager" "License Manager" \
	"Press this button to display and manage licenses" \
	{
	}

configButtonAndLabel .t.top "help" "Help" \
	"Press this button to get help info such as documentation, tutorials, ..." \
	{
	}

configButtonAndLabel .t.top "info" "Info/About" \
	"Press this button to get info about this release (version, authors, ...)" \
	{
	}

configButtonAndLabel .t.top "close" "Close" \
	"Press this button to close this window" \
	{
		exit 0
	}

grid columnconfigure .t.top 1 -weight 100
grid columnconfigure .t.top 1 -minsize $explainTextWidth
pack .t.top -expand 0 -anchor nw -fill both

grid configure .t.top -in .t
grid configure .t.top -sticky ew 

##########################
# Record  menu
##########################

frame .t.rec 

configStartSection3 .t.rec "secProfile" "Choose Recording Profile" "Step 1" "if unsure choose \"default\""

configComboBoxAndLabel3 .t.rec "recProfile" "Recording Profile" \
	"Please select the recording profile that you want to use. (you may adjust the config below if the profile does not fit 100%) " \
	"recProfile" \
	{ a b c  }
	
configEndSection3 .t.rec "secProfile"
	
configStartSection3 .t.rec "secMode" "Choose Recording Mode" "Step 2" "if unsure choose \"OpenGL/Animation Mode\""

configRadioButtonSet3 .t.rec "recMode" "Recording Mode" \
	"RecordingMode general explain" \
	"recMode" \
	{
		{ "capRec" 1 "OpenGL/Animation Mode" " This is the default mode. It records the main desktop or a selectable area of it. Supports OpenGL and Animations." }
		{ "proxyNested" 1 "Nested Desktop Mode" "This is a special mode which records a virtual desktop which is nested inside a window. " }
		{ "proxyFullscreen" 0 "Long Term Recording Mode" "Special: Records main desktop for hours while generating modest video-size. Requires sysadmin skills to setup. No OpenGL." }
	} 

#Read more text for proxyNested: This is useful if you want to record a complete desktop in a smaller resolution. However this mode cannot record OpenGL apps 
#Read more text for proxyFullscreen:  It requires changes in the system setup, which also make OpenGL unavailable on the system, even if not recording.			

configEndSection3 .t.rec "secMode"

proc showRecMode { varname args } {
	global recMode 
	puts stdout "recMode = $recMode\n" 
}

trace variable recMode w "showRecMode"

set recMode "capRec"

configStartSection3 .t.rec "secNav" "Navigation" "Navigation" ""

configButtonAndLabel3 .t.rec "toMain" "Back to Main Menu" \
	"Press this button to display the main menu" \
	{
		grid forget .t.rec
		grid configure .t.top -in .t
	}

configButtonAndLabel3 .t.rec "close" "Close" \
	"Press this button to close this window" \
	{
		exit 0
	}

configEndSection3 .t.rec "secNav"

puts stdout "leftColumns = $leftColumns"

grid columnconfigure .t.rec [ expr 2 + [ llength $leftColumns ] ] -weight 100
grid columnconfigure .t.rec [ expr 2 + [ llength $leftColumns ] ] -minsize $explainTextWidth
pack .t.rec -expand 0 -anchor nw -fill both

grid configure .t.rec -in .t
grid configure .t.rec -sticky ew 
grid forget .t.rec

##########################

grid columnconfigure .t 1 -weight 100
pack .t -expand 0 -anchor nw -fill both
 
wm resizable . 0 0

