#tcl script

########################################################
# DemoRecorder Launchpad
#
# Copyright (C) 2009 Christian Linhart <chris@DemoRecorder.com>
########################################################

package require drWidgetFileSelection 1.0
package require drUtils 1.0
package require drGuiLayoutWithSections 1.0

#*** GUI ***
frame .t

wm title . "DemoRecorder"


#Headline
#label .t.hello -text "DemoRecorder"

#grid configure .t.hello -in .t

 

ttk::style configure EvenStyle.TRadiobutton -background #999999
ttk::style map EvenStyle.TRadiobutton -background  [ list disabled #999999 active #FF9999 ]

ttk::style configure OddStyle.TRadiobutton -background  #BBBBBB 
ttk::style map OddStyle.TRadiobutton -background  [ list disabled #BBBBBB active #FFBBBB ] 

#ttk::style configure TRadiobutton -background #FF0000




::dr::gui::layoutWithSections::StartSectionList3 .t "top" 

#configButtonAndLabel .t.top "record" "Record" \
#	"Press this button to open the recording dialog" \
#	{
#		grid forget .t.top
#		grid configure .t.rec -in .t
#	}

::dr::gui::layoutWithSections::StartSection3 .t.top "mainFeatures" "DemoRecorder Tools" "" "Please choose a tool and press the button"

if { 0 } {
::dr::gui::layoutWithSections::ButtonAndLabel3 .t.top "record-native" "Record" \
	"Select a rectangular area (or fullscreen) and record it" \
	{
		puts  "starting $env(DEMOREC_DIR)/bin/demorec-opengl"
		exec "$env(DEMOREC_DIR)/bin/demorec-opengl" &
		exit 0
	}

::dr::gui::layoutWithSections::ButtonAndLabel3 .t.top "record-native-with-options" "Record With Options" \
	"Opens a dialog, which allows you to specify recording options before recording. You can also choose fullscreen recording this way." \
	{
		puts  "starting $env(DEMOREC_DIR)/bin/demorec-opengl"
		exec "$env(DEMOREC_DIR)/bin/demorec-opengl" "--with-rec-options-dialog" &
		exit 0
	}
}

::dr::gui::layoutWithSections::ButtonsAndLabel3 .t.top \
	{
		{ "record-native1" "Record"
			{
				puts  "starting $env(DEMOREC_DIR)/bin/demorec-opengl"
				exec "$env(DEMOREC_DIR)/bin/demorec-opengl" &
				exit 0
			}
		}
		{ "record-native-with-options1" "with options"
			{
				puts  "starting $env(DEMOREC_DIR)/bin/demorec-opengl"
				exec "$env(DEMOREC_DIR)/bin/demorec-opengl" "--with-rec-options-dialog" &
				exit 0
			}
		}
	} \
	"Select a rectangular area (or fullscreen) and record it. If you press \"with options\" it allows you to specify recording options before recording. You can also choose fullscreen recording this way."

#configButtonAndLabel .t.top "record-native-area" "Record Area" \
#	"Select a rectangular area and record it" \
#	{
#		puts  "starting $env(DEMOREC_DIR)/bin/demorec-opengl-autoname"
#		exec "$env(DEMOREC_DIR)/bin/demorec-opengl-autoname" &
#	}

#configButtonAndLabel .t.top "record-native-fullscreen" "Record Fullscreen" \
#	"Record the full screen ( you need a Pro-license for that )" \
#	{
#		puts  "starting $env(DEMOREC_DIR)/bin/demorec-opengl-autoname"
#		exec "$env(DEMOREC_DIR)/bin/demorec-opengl-autoname" "--fullscreen" &
#	}


::dr::gui::layoutWithSections::ButtonsAndLabel3 .t.top \
	{
		{ "play" "Preview Playback" \
			{
				puts  "starting $env(DEMOREC_DIR)/bin/demorec --playback-save-and-export-only"
				exec "$env(DEMOREC_DIR)/bin/demorec" "--playback-save-and-export-only" &
			}
		}
		{ "play-with-options" "with options" \
			{
				puts  "starting $env(DEMOREC_DIR)/bin/demorec --playback-save-and-export-only"
				exec "$env(DEMOREC_DIR)/bin/demorec" "--playback-save-and-export-only" "--with-demorec-gui-options-dialog" &
			}
		}
	} \
	"Press this button to play a raw, unexported DemoRecorder video" \

::dr::gui::layoutWithSections::ButtonAndLabel3 .t.top "export" "Export Video" \
	"Press this button to export a DemoRecorder video to some common file format such as AVI, FLV, MPEG 1/2/4, ..." \
	{
		puts  "starting $env(DEMOREC_DIR)/bin/demorec-exporter"
		exec "$env(DEMOREC_DIR)/bin/demorec-exporter" &
	}

#configButtonAndLabel .t.top "play" "Play" \
#	"Press this button to play a demorecorder video" \
#	{
#	}

#configButtonAndLabel .t.top "preferences" "Preferences" \
#	"Press this button to change preferences and config of DemoRecorder" \
#	{
#	}

#configButtonAndLabel .t.top "licenseManager" "License Manager" \
#	"Press this button to display and manage licenses" \
#	{
#	}

#configButtonAndLabel .t.top "help" "Help" \
#	"Press this button to get help info such as documentation, #tutorials, ..." \
#	{
#	}

#configButtonAndLabel .t.top "info" "Info/About" \
#	"Press this button to get info about this release (version, #authors, ...)" \
#	{
#	}


::dr::gui::layoutWithSections::EndSection3 .t.top "mainFeatures"

#configStartSection3 .t.top "advanced" "Advanced Features" "" "Advanced features need a system administrator to be setup"

#configButtonAndLabel3 .t.top "record-247" "24/7 Recording" \
#	"Long-term recording (of possibly mission critical systems). This requires a system administrator to be setup, and you need a license of the \"24/7\"-edition of DemoRecorder. Pressing the button will show you a text explaing more details. Or ask chris@DemoRecorder.com by email." \
#	{
#		::dr::utils::OpenWebpage "http://www.DemoRecorder.com/appmenu/24-7-recording.php"
#	}

#configEndSection3 .t.top "advanced"

::dr::gui::layoutWithSections::StartSection3 .t.top "bonus" "Bonus Features (unsupported)" "" "Bonus features are unsupported and may not work on all systems"

::dr::gui::layoutWithSections::ButtonsAndLabel3 .t.top {
	{ "record-nested" "Record Nested Desktop"
		{
			puts  "starting $env(DEMOREC_DIR)/bin/demorec --nested"
			exec "$env(DEMOREC_DIR)/bin/demorec" "--nested" &
		}
	}
	{ "record-nested-with-options" "with options"
		{
			puts  "starting $env(DEMOREC_DIR)/bin/demorec --nested"
			exec "$env(DEMOREC_DIR)/bin/demorec" \
				"--nested" \
				"--with-demorec-gui-options-dialog" \
				"--demorec-gui-options-dialog-mode" \
					"nested-rec" &
		}
	}
} "Record a nested virtual desktop. (This bonus feature is not supported, and may not work on all systems.)"

::dr::gui::layoutWithSections::EndSection3 .t.top "bonus"

::dr::gui::layoutWithSections::StartSection3 .t.top "licenseSection" "Licenses" "" ""

::dr::gui::layoutWithSections::ButtonAndLabel3 .t.top "evalLicense" "Get Eval License" \
	"Get a free, 30 day, fully functional evaluation license" \
	{
		::dr::utils::OpenWebpage "http://www.DemoRecorder.com/appmenu/get-eval-license.php"
	}

::dr::gui::layoutWithSections::ButtonsAndLabel3 .t.top {
	{ "buy" "Buy Online"
		{
			::dr::utils::OpenWebpage "http://www.DemoRecorder.com/shop"
			#::dr::utils::OpenWebpage "http://www.DemoRecorder.com/appmenu/buy-online.php"
		}
	}
	{ "howto-buy" "How to Buy"
		{
			::dr::utils::OpenWebpage "http://www.DemoRecorder.com/appmenu/how-to-buy.php"
		}
	}
} "Buy licenses online / How to Buy Licenses with other methods such as by purchase order."

::dr::gui::layoutWithSections::ButtonAndLabel3 .t.top "activate" "Activate License" \
	"Activate License" \
	{
		#get hostid
		set commandline "$env(DEMOREC_DIR)/bin/demorec_hostid"
		set cmd "/bin/sh -c \"$commandline 2>&1\""
		set f [open "| $cmd" r]
		set hostidSpec [ read $f ]
		close $f

		set hostid [ string map { "hostid = " "" } "$hostidSpec" ]

		puts "got hostid $hostid";
		
		::dr::utils::OpenWebpage "http://www.DemoRecorder.com/appmenu/activate-license.php?hidprefill=$hostid"
	}

#configButtonAndLabel3 .t.top "licenseinfo" "Show License Info" \
#	"Show installed licenses." \
#	{
#		
#	}

::dr::gui::layoutWithSections::EndSection3 .t.top "licenseSection"

::dr::gui::layoutWithSections::StartSection3 .t.top "closeSection" "" "" ""

::dr::gui::layoutWithSections::ButtonAndLabel3 .t.top "download" "Download" \
	"Download current version" \
	{
		::dr::utils::OpenWebpage "http://www.DemoRecorder.com/appmenu/download.php"
	}

#configButtonAndLabel3 .t.top "about" "About" \
#	"Show current version number and some other infos." \
#	{
#		
#	}

::dr::gui::layoutWithSections::ButtonAndLabel3 .t.top "close" "Close" \
	"Press this button to close this window" \
	{
		exit 0
	}

::dr::gui::layoutWithSections::EndSection3 .t.top "closeSection"



::dr::gui::layoutWithSections::EndSectionList3 .t "top"


##########################
# Record  menu
##########################

frame .t.rec 

::dr::gui::layoutWithSections::StartSection3 .t.rec "secProfile" "Choose Recording Profile" "Step 1" "if unsure choose \"default\""

::dr::gui::layoutWithSections::ComboBoxAndLabel3 .t.rec "recProfile" "Recording Profile" \
	"Please select the recording profile that you want to use. (you may adjust the config below if the profile does not fit 100%) " \
	"recProfile" \
	{ a b c  }
	
::dr::gui::layoutWithSections::EndSection3 .t.rec "secProfile"
	
::dr::gui::layoutWithSections::StartSection3 .t.rec "secMode" "Choose Recording Mode" "Step 2" "if unsure choose \"OpenGL/Animation Mode\""

::dr::gui::layoutWithSections::RadioButtonSet3 .t.rec "recMode" "Recording Mode" \
	"RecordingMode general explain" \
	"recMode" \
	{
		{ "capRec" 1 "OpenGL/Animation Mode" " This is the default mode. It records the main desktop or a selectable area of it. Supports OpenGL and Animations." }
		{ "proxyNested" 1 "Nested Desktop Mode" "This is a special mode which records a virtual desktop which is nested inside a window. " }
		{ "proxyFullscreen" 0 "Long Term Recording Mode" "Special: Records main desktop for hours while generating modest video-size. Requires sysadmin skills to setup. No OpenGL." }
	} 

#Read more text for proxyNested: This is useful if you want to record a complete desktop in a smaller resolution. However this mode cannot record OpenGL apps 
#Read more text for proxyFullscreen:  It requires changes in the system setup, which also make OpenGL unavailable on the system, even if not recording.			

::dr::gui::layoutWithSections::EndSection3 .t.rec "secMode"

proc showRecMode { varname args } {
	global recMode 
	puts stdout "recMode = $recMode\n" 
}

trace variable recMode w "showRecMode"

set recMode "capRec"

::dr::gui::layoutWithSections::StartSection3 .t.rec "secNav" "Navigation" "Navigation" ""

::dr::gui::layoutWithSections::ButtonAndLabel3 .t.rec "toMain" "Back to Main Menu" \
	"Press this button to display the main menu" \
	{
		grid forget .t.rec
		grid configure .t.top -in .t
	}

::dr::gui::layoutWithSections::ButtonAndLabel3 .t.rec "close" "Close" \
	"Press this button to close this window" \
	{
		exit 0
	}

::dr::gui::layoutWithSections::EndSection3 .t.rec "secNav"

puts stdout "leftColumns = ${::dr::gui::layoutWithSections::leftColumns}"

::dr::gui::layoutWithSections::EndSectionList3 .t "rec"

grid forget .t.rec

##########################

grid columnconfigure .t 1 -weight 100
pack .t -expand 0 -anchor nw -fill both
 
wm resizable . 0 0

