#!/bin/sh

#Functions
handle_dtlogin() {
	#Check for proesses running in order to determine the type of session
	processesFile=${tmpPrefix}processes
	ps -ewf >$processesFile

	sessionName="default"
	
	for candidate_session in ` grep -w "dtsession -session" $processesFile  | sed -e 's/^.*-session *//' -e 's/ .*$//' ` ; do
		sessionName=$candidate_session
	done
	echo $displayManager $sessionName
}

handle_xinit() {
	#Check for proesses running in order to determine the type of session
	processesFile=${tmpPrefix}processes
	ps -ewf | grep -w xinit | grep -v "grep -w" >$processesFile
	for candidate_session in ` sed -e 's/^.*xinit \s*//' -e 's/\-\-.*$//' < $processesFile` ; do
		sessionName=$candidate_session
	done
	echo $displayManager $sessionName
}

#main script
tmpPrefix=/tmp/demorec-guess-current-xsession.$$.
#1. Guess the display-manager

	#Check for envvars like GDMSESSION, 
	if [ -n "$GDMSESSION" ] ; then
		#gdm is in use and the session-name is stored in GDMSESSION
		echo gdm $GDMSESSION
		exit 0
	fi

	#2. Guess the type of session running based on env-vars
	if [ -n "$DESKTOP_SESSION" ] ; then
		sessionName=` echo "$DESKTOP_SESSION"| sed -e 's/^[0-9]*//' `
	elif [ "$KDE_FULL_SESSION" = "true" ] ; then
		sessionName="kde"
	elif [ -n "$GNOME_DESKTOP_SESSION_ID" ] ; then
		sessionName="gnome"
	elif [ -n "$DTUSERSESSION" ] ; then
		displayManager=dtlogin
		handle_dtlogin
		exit 0
	else
		sessionName="default"
	fi

	#Check for proesses running in order to determine the display-manager and other session-controllers
	processesFile=${tmpPrefix}processes
	ps -e >$processesFile
	
	if grep -w gdm $processesFile >/dev/null ; then
		displayManager=gdm
	elif grep -w kdm $processesFile >/dev/null ; then
		displayManager=kdm
	elif grep -w xdm $processesFile >/dev/null ; then
		displayManager=xdm
	elif grep -w mdkkdm $processesFile >/dev/null ; then
		displayManager=mdkkdm
	elif grep -w dtlogin $processesFile >/dev/null ; then
		displayManager=dtlogin
		handle_dtlogin
		exit 0
	elif grep -w xinit $processesFile >/dev/null ; then
		displayManager=xinit
		handle_xinit
		exit 0
	else
		displayManager=none
	fi

	#output
	echo $displayManager $sessionName

	
	
	

