

usage_option_resolution() {
	cat <<'eof'
	--resolution widthxheight
		e.g. --resolution 1024x768
		resolution of the output-movie. 
		If the input has another resolution, the movie 
		is scaled accordingly.
		
		Default: use original resolution of the recording.
		Default for PAL: 720x576
		Default for NTSC: 720x480
		
eof
}

usage_option_frame_rate_basic() {
	cat <<'eof'
	--frame-rate n
	--fps n
	--frames-per-second n
		specifies the frame-rate "n" in frames per second.
		This frame-rate is both 
		the frame-rate used for capturing the demorecorder-movie 
		as well as the frame-rate of the generated movie.
		The frame rate may be a a floating point number.
		
		Default: 25 frames per second.
		Default for NTSC: 29.97 frames per second.
		
eof
}
		
usage_option_frame_rate() {
	usage_option_frame_rate_basic
	cat << 'eof'
	--capture-frames-per-second n
		specifies the frame-rate "n" used for capturing 
		the demorecorder-movie.
		The frame-rate of the generated movie is not affected.
		
		The difference between both frame-rates may be used 
		for frame-oversampling which may 
		be used for temporal anti-aliasing
		(depending on the capabilities of the codec).
		
		Default: use frame rate set with --fps 
			( or the default specified for --fps )
		
	--output-frames-per-second n
		specified the frame-rate "n" used for the generated movie.
		The frame rate for capturing the demorecorder-movie 
		is not affected.

		Default: use frame rate set with --fps
			( or the default specified for --fps )

eof
}

usage_option_output_bitrate_basic() {
	cat << 'eof'
	--output-bitrate n
		specifies the (average) video-bitrate "n" 
		of the generated movie in kbits/second.
		This option only makes sense for lossy codecs such as MPEGx.
		
		Defaults: 
			for MPEG4 and MPEG1: 2000 kbits/sec
			for AVI : 4000 kbits/sec
			for MPEG2 and VOB: 6000 kbits/sec
			
eof
}

usage_option_output_bitrate() {
	usage_option_output_bitrate_basic
	cat << 'eof'
	--output-min-bitrate n
		specifies the minimum video-bitrate "n" of the generated movie.
		
		Default: no min-bitrate
		
	--output-max-bitrate n
		specifies the maximum video-bitrate "n" of the generated movie.

		Default: no max-bitrate
		
eof
}

usage_option_output_sound_bitrate() {
	cat << 'eof'
	--output-sound-bitrate n
		specifies the (average) sound-bitrate "n" used 
		for the sound-track of the generated movie in kbits/second.

		Default: 64 kb/sec
		
eof
}

usage_option_output_sound_samples_per_second() {
	cat << 'eof'
	--output-sound-samples-per-second n
		specifies the number of samples per second in the output.
		
		Default: 
			FLV: 22050
			other formats: same as in the original video
			
		Allowed values:
			FLV: 11050 or 22050
			other: this option is not supported yet for target formats other than FLV
eof
}

usage_option_no_sound() {
	cat << 'eof'
	--no-sound
		don't include the sound in the exported video.

eof
}

usage_option_output_codec() {
	cat << 'eof'
	--output-codec codecname
		specifies the name of the output-codec "codecname".
		This is an advanced option for experts.
		We refer to the ffmpeg-documentation for a list of codecs.

eof
}

usage_option_bframes() {
	cat << 'eof'
	--bframes n
		specifies the number of B-frames which is applicable 
		to some MPEG-codecs.
		This is an advanced option for experts.

eof
}

usage_option_help() {
	cat << 'eof'
	--help
		displays this help text.

eof
}

usage_option_licensepath() {
	cat << 'eof'
	--license-path licensedir
		set the directory where to look for license files

eof
}

usage_option_tempdir() {
	cat << 'eof'
	--tempdir tempdirname
		set the directory where to put temporary files to

eof
}
usage_option_with_player() {
	cat << 'eof'
	--with-player
	--generate-player
eof
	case "$1" in
		swf_flv)
			did_show_usage_option_with_player="true"
			cat << 'eof'
		generates all files necessary for web-publishing, that is:
			* the FLV video which contains your screen recording 
			   -> your-recording.flv
			* an SWF-file which contains a player for the FLV video
			   (the player has a GUI for controlling the playback 
			   of the video)
			   ->  your-recording.swf
			* an HTML-file which contains HTML-code
			   which has to be copied into the HTML-code of the
			   webpage where you want to show your video.
			   -> your-recording.html

eof
		;;
	esac
}

usage_option_with_loader() {
	cat << 'eof'
	--with-loader
	--generate-loader
eof
	case "$1" in
		swf_flv)
			if [ "$did_show_usage_option_with_player" = "true" ] ; then
				cat << 'eof'
		like --with-player but without GUI for controlling the playback.

eof
			else
				cat << 'eof'
		generates all files necessary for web-publishing, that is:
			* the FLV video which contains your screen recording 
			   -> your-recording.flv
			* an SWF-file which contains a loader for the FLV video
			   (the loader just displays the video but has no GUI)
			   ->  your-recording.swf
			* an HTML-file which contains HTML-code
			   which has to be copied into the HTML-code of the
			   webpage where you want to show your video.
			   -> your-recording.html

eof
			fi
		;;
	esac
}

usage_option_autoplay() {
	cat << 'eof'
	--autoplay
		the exported video starts playing automatically
	
		Default: off
			
eof
}

usage_option_autorepeat() {
	cat << 'eof'
	--autorepeat
		the exported video repeats playback after it reached 
		the end of the video.

		Default: off

eof
}

usage_option_controller_mode() {
	cat << 'eof'
	--controller-mode mode
		sets the mode of the controller-GUI of the player.
		mode can be one of
			on     switches on the GUI for controlling the player
			off    switches off the GUI for controlling the player
			auto   the GUI is only completely visible when 
				   the mouse moves over it.
			none   there is no GUI, just the movie is displayed

		Default: on, when --with-player is used.

eof
}

usage_option_affiliate_id() {
	cat << 'eof'
	--affiliate-id your-esellerate-affiliate-id
		Make money with commissions:
		1. Go to 
				http://affiliates.eSellerate.net 
			to sign up as an affiliate.
		2. Please replace your-esellerate-affiliate-id 
		   with your esellerate affiliate id
		   which starts with "AFL". Please include the "AFL".
		   (or set the variable ESELLERATE_AFFILIATE_ID 
		   in the preferences, 
		   e.g. in $HOME/.DemoRecorder/preferences)
		3.When somebody clicks on the "recorded with DemoRecorder"-logo
		   on the player at your website, 
		   and when they buy DemoRecorder licenses,
		   then you get a commission. 
		   (we refer to the Affiliate-Agreement from eSellerate
		   for details and specific conditions.)

eof
}

usage_option_no_logo() {
	cat << 'eof'
	--no-logo
		don't show the "recorded with DemoRecorder"-logo 
		in the button area of the player.

		Default: show the logo
		
eof
}

usage_option_startend() {
	cat << 'eof'
	--start rel-starttime
		start exporting at rel-starttime which is 
		relative to the begin of the video.
		"rel-starttime" is in one of the following formats: 
			h:m:s,  h:m:s.x, m:s, m:s.x, s, s.x
		where 
			h is the number of hours,
			m is the number of minutes,
			s is the number of seconds,
			x is fractional seconds, 
			  i.e. the part after the decimal point
			  
		Default: start at the beginning of the recording.
			
	--end rel-endtime
		finish exporting at rel-endtime which is 
		relative to the begin of the video.
		"rel-endtime" is in the same format as "rel-starttime" 
		for the option "--start"
		
		Default: finish at the end of the recording
	
eof
}

usage_option_hide_cursor() {
	cat << 'eof'
	--hide-cursor
		Hide the X-cursor on exporting.
		This is useful when exporting recordings of VMware
		because the cursor in the virtual machine is not the X-cursor.
		
		Default: show the cursor
		
eof
}

usage_option_speed_factor() {
	cat << 'eof'
	--speed-factor factor
		speed up the exported video by factor "factor".
		"factor" can be a floating point value. 
		With values smaller than 1.0, 
		the exported video can be made slower.
		Setting a speed factor implies disabling of sound.
		
		Default: 1.0
		
eof
}

usage_option_rectangle() {
	cat << 'eof'
	--rectangle widthxheight+x+y
		Export from a rectangular area of the original video.
		x is the number of pixels from the left edge of the original video 
			to the left edge of the rectangle.
		y is the number of pixels from the upper edge of the original video 
			to the upper edge of the rectangle.
		width is the width of the rectangle in pixels
		height is the height of the rectangle in pixels
		
		Default: Show whole recording.
		
eof
}

usage_option_sound_volume() {
	cat << 'eof'
	--sound-volume volume
		
		Default: 1.0
		
eof
}

usage_option_sound_timeshift() {
	cat << 'eof'
	--sound-timeshift timeshift

		Default: 0
		
eof
}

usage_option_sound_timefactor() {
	cat << 'eof'
	--sound-timefactor timefactor
		Make sound run faster by timefactor compared to the video.
		This option is primarily intended as a workaround in case of 
		unknown bugs in the demorec-exporter or in case of bugs in 
		3rdparty players or 3rdparty importers.

		Default: 1.0
		
eof
}

usage_option_youtube() {
	cat << 'eof'
	--youtube
	
		Generate the movie with parameters optimized for YouTube.
		( Equivalent to 
			--fps 30 --resolution 640x480 -output-bitrate 2000 -output-sound-bitrate 128 
		)
		
eof
}

usage_option_google() {
	cat << 'eof'
	--google
	
		Generate the movie with parameters optimized for Google Video.
		( Equivalent to 
			--fps 30 --resolution 640x480 --output-bitrate 2000 -output-sound-bitrate 128 
		)
		
eof
}

usage_option_select_area() {
	cat << 'eof'
	--screen-follows-mouse

		This option specifies that the screen containing 
		the mouse-pointer is exported.

	--screen-num n

		This option specifies that the contents of screen number n 
		are to be exported.
		( n is a number greater or equal 0 and less than the number 
		of screens in the recording )

		Please note: --screen-follows-mouse has precedence over --screen-num.
		(in this case, --screen-num is only used if the screen of the 
		mouse-pointer cannot be determined)

		Default: 0
		
	--keep-screen-time timespan
	
		In mode --screen-follows-mouse:
			Keep the screen for" timespan" time after a switch 
			to another screen.
			This avoids very fast multiple switches due to the mouse 
			jumping fast between screens on moving it along the border
			between those two screens.
			
		timespan is given in seconds and may be specified as floating point number.
		
		Only applies if the cursor is within the delay-and-keep-region.
		(c.f. --screen-switch-delay-and-keep-region-width)
		
	--screen-switch-delay timespan
	
		In mode --screen-follows-mouse:
			Delay switch to another screen for "timespan" time.
			Same reasoning as for --keep-screen-time.

		Only applies if the cursor is within the delay-and-keep-region.
		(c.f. --screen-switch-delay-and-keep-region-width)
		
	--screen-switch-delay-and-keep-region-width width
	
		In mode --screen-follows-mouse:
			the delay timer and the keep timer for a screen-switch
			only apply if the cursor is within "width" pixels from 
			the border of the screen.
			
			Therefore we still avoid fast multiple switches when moving
			along the border but we get an immediate reaction 
			when the mouse is decisively moved well into the other screen.
	
eof
}

usage_option_batch() {
	cat << "eof"
	--batch listOfInputFiles

		This option specified a list of input files to be exported/rendered.
		The names of the corresponding outputfiles are computed by
		$scriptname
		
		By default, the name of each outputfile is computed by
		adding the extension \"$defaultBatchExtension\" 
		to the corresponding inputname.
		
		The computation of the outputfilenames can
		be influenced with the options \"--batch-target-dir\",
		\"--batch-extension\" and \"--batch-prefix\"			
		
		The listOfInputFiles is a list of files, separated by whitespace.
		If used from a shell, the list may contain filenames 
		with shell-glob characters ( \"*\" and \"?\", ... ) , e.g.
			$scriptname --batch myvideo*
		
		Please note:
		 
		* --batch must be the last option on the commandline
			because everything which comes after \"--batch\"
			is interpreted as a filename, even if it starts with a \"-\".
			
		* The inputfiles on the list must not contain blanks 
		   in their filenames. ( Quoting does not help )
		  
		* inputfiles which are not a demorecorder videos
		  are ignored. Therefore it is safe to specify filename
		  patterns such as \"myvideo*\" even if exported files
		  such as avi-files are also matching. 
		
	--batch-target-dir
		specifies the target-dir for batchmode outputfiles
	
	--batch-extension
		specifies the filename extension for batchmode outputfiles
		Please note: please include the \".\" or any other separation characters
		which the extension uses.
		
		e.g.
			--batch-extension .avi
	
	--batch-prefix
		specifies a prefix which is added at the start of an outputfilename
		in batchmode. The prefix is added to the basename, 
		i.e. after the directory-name.

eof
}

usage_option_overlay() {
	cat << "eof"
	--overlay overlay-description
		places an overlay over the video.
		This can e.g. be used to put your logo in some corner 
		of the video.
	
		The overlay-description, which should be put in quotes, 
		is a comma separated lists of functions.
		e.g.
			"image(/Projects/Test/Face1.ppm),alpha(/Projects/Test/Face1-alpha.pgm),pos(120,240)"
		
		The following functions are supported:

		* image(filename)
			sets the filename for the image to be displayed 
			as an overlay.
			As of now, only ppm-files are allowed. ( this may change
			later, most probably png will be allowed to, at least )

		* alpha(filename)
			sets the filename for the alpha-mask to be used.
			The alpha mask has to be the same resolution as the image.
			 As of now, only pgm-files are allowed. 
			 ( this may change later )

		* pos(x,y)
			  sets the position of the upper left corner of the image 
			  in the video.
			  
eof
}

usage_option_overlay_windows() {
	cat << "eof"
	--overlay-windows-graphics-expose-timeout timespan
		Set the timeout for waiting for graphics expose events
		as used by overlay windows.
		Usually this timeout should never expire and therefore 
		it should not be relevent, but in case of bugs or 
		exceptional conditions, this timeout may expire 
		due to missing graphics expose events.
		This may cause slow exporting.
		By decreasing the timeout to 0.0001 or a similar 
		value of seconds, you can speed up exporting in those events.
		( expiry of the timeout is indicated by the following warning 
		during exporting:
		"warning: overlayWindows: timeout for GraphicsExpose Events reached" )
		
eof
}

#general options for exporter
usage_general_options() {
	usage_option_sound_volume
	usage_option_sound_timeshift
	usage_option_sound_timefactor
	usage_option_select_area
	usage_option_batch
	usage_option_overlay
	usage_option_overlay_windows
	usage_option_licensepath
}

usage_pointer() {
	echo "invoke with option --help in order to get usage info."
}

usage_options_demorec() {
	cat << "eof"
	--width width
		set the width of the nested desktop which is recorded
		or set the width of the recording area of the frame-based recording engine.
		
		Default for nested desktop: 800

	--height height
		set the height of the nested desktop which is recorded.
		or set the height of the recording area of the frame-based recording engine.

		Default for nested desktop: 600

	--x x
		set the x-coordinate of the upper left corner of the recording area
		only applies to the frame-based (OpenGL/Animation) 
		recording mode.
		
	--y y
		set the y-coordinate of the upper left corner of the recording area
		only applies to the frame-based (OpenGL/Animation) 
		recording mode.
	
	--screen-num n
		the recording area is on screen \"n\".
		Where  \"n\" can be any integer number between 0
		and the number of screens minus one.
		
		Default: the default screen of the display ( as specified
			by the \$DISPLAY envvar. )
	
	--windowId w
		set the initial position of the recording area to the 
		extents of the window with the given window-id \"w\".
		\"w\" can be any valid window-id of the X11-display.
		It can be specified as decimal number 
		or as a hexadecimal number starting with \"0x\".
	
	--minPauseMsec pause
		specifies the pause between frame captures. This frees some more CPU for your apps.
		only applies to the frame-based (OpenGL/Animation) 
		recording mode.
		
		Default: 20
	
	--maxFps fps
		specified the maximum framerate.
		only applies to the frame-based (OpenGL/Animation) 
		recording mode.
	
		Default: 25.0

	--maxCPU cpupercent
		specified the maximum cpu-time usage 
		by the recording process. ( in percent ).
		only applies to the frame-based (OpenGL/Animation) 
		recording mode.
	
		Default: 50
		
	--out filename
		specifies the name of the recorded video
		only applies to the frame-based (OpenGL/Animation) 
		recording mode.
		
	--autoname
		automatically computes the filename of the recorded video.
		The filename is as follows: 
			~/demorec/demorec-video-YYYYMMDD-hhmm-C
		  where:
		  	YYYY is the year
		  	MM is the month ( two digits 01-12 )
		  	DD is the day of month ( two digits 01-31 )
		  	hh is the hour
		  	mm is the minutes
		  	C is a counter to disambiguate two recordings made 
		  	in the same minute,
		  		this counter starts with 1.
		  		
		 Example: 
			~/demorec/demorec-video-20080714-1024-1
		  		 
		this option only applies to the frame-based 
		(OpenGL/Animation) recording mode.

	--auto-alternative-name
		if the chosen filename already exists, then automatically
		choose another filename instead of asking interactively.
		The alternative filename will be the original filename 
		with a hypen and a number appended, e.g.

			orig filename: demorec/myvideo
			alternative filename: demorec/myvideo-7
			
		(the number will be as low as possible. In this example,
		myvideo-1, myvideo-2, ..., myvideo-6 )
		
	--sound
		enable sound-recording (default)

	--no-sound
		disable sound-recording
		
	--sound-rec-device devicename
		specifies the device which is used as the 
		source of the sound to be recorded.
		
		Default: /dev/dsp

	--sound-play-device devicename
		specifies the device which is used for 
		playing back sound.
		
		Default: /dev/dsp		
		
	--hifi
	--hifi-stereo
		enable high quality stereo sound recording.
		This means 
		* 44100 Hz Samplerate,
		* no sound compression
		* stereo ( i.e. 2 channels )
		* 16 bits per sample
		
	--hifi-mono
		enable high quality mono sound recording.
		This means 
		* 44100 Hz Samplerate,
		* no sound compression
		* mono ( i.e. one channel )
		* 16 bits per sample

	--sound-samples-per-second n
		configure the number of samples per second for sound recording.
		The value you set must be supported by your sound card.
		usual values for n are e.g. 22050 or 44100.
		
	--sound-channels n
		set the number of sound-channels.
		The value you set must be supported by your sound card.
		For mono, n is 1. For stereo, n is 2.
		
	--mono
		configure mono sound recording. 
		("--mono" is equivalent to "--sound-channels 1")
		
	--stereo
		configure stereo sound recording. 
		This must be supported by your sound card.
		Stereo recording only makes sense with a stereo microphone
		or another stereo audio source.
		("--stereo" is equivalent to "--sound-channels 2")
		
	--sound-bits-per-sample	n
		configure the bits per sample to be used.
		This must be supported by your sound card.
		
	--sound-compression-method method
		Sets the sound compression method used 
		for recording the original video.
		(on exporting to other formats, 
		other compression methods can be chosen)
		
		Supported values:
			* oggvorbis
				use Ogg/Vorbis sound compression
				
			* none
				no compression means highest quality,
				but it needs a lot of disk space 
				for the original recording. 
				It does not affect the size of exported videos,
				so if you have enough disk space, 
				then go for it.
		
	--sound-no-compression
		disable sound compression for highest sound quality
		(equivalent to "--sound-compression-method none" )
		
	--fade-in-time-msecs n
		specify the length of the fade-in period after resuming
		the recording after a pause. ( in milliseconds )
		
		Default: 50
			
	--fade-out-time-msecs n
		specify the length of the fade-out period before pausing
		the recording. ( in milliseconds )
		
		Default: 50
	
	--split-sound-files-secs n
		Sound files are split every n seconds
		
		Default: disabled ( sound files are not split )
		
	--dont-split-sound-files
		Sound files are not split
		
		Default: This is the default behavior
	
	--sound-bitrate n
		specifies the (average) sound-bitrate "n" used 
		for the sound-track of the generated movie in kbits/second.

		Default: 64 kbits/sec
		
	--fullscreen
		fullscreen mode,
		
	 	Can be combined with the --opengl-hw mode or used with the classic 
	 	recording mode.
	 	
	 	If used with --opengl-hw, no further config is necessary.
	 	
	 	If used with the classic recording mode,
		this mode needs changes in your X-configuration 
		before and is usually autodetected then.
		So, you usually don't need this option.
		
		Instructions for changing your X-configuration
		for using full screen mode can be found in the file
eof
        echo "                $DEMOREC_DIR/doc/InstallFullscreen.txt"
        cat << 'eof'

	--nested
		nested mode.
		With this switch, nested mode may be enforced 
		even when the X-Configuration has been prepared 
		for full-screen recording.
		
	--caprec
	--frame-based
	--opengl-hw
		Frame-based recording engine.
		This engine requires powerful hardware to achieve good results.
		It is most useful for recording OpenGL applications because it
		supports hardware-accelerated OpenGL 
		(which the frameless recording engine does not yet support)
		
		Please select the name of the output with option "--out".
		If generates output which is compatibel with the export filters of DemoRecorder.
		
		The following options apply to that engine
			--x , --y, --width, --height, --minPauseMsec, --maxFps
		
		THIS IS STILL EXPERIMENTAL AND ITS USAGE MAY CHANGE. 
		Please contact me for details at chris@DemoRecorder.com.
		
	--no-shape
		disable the use of the SHAPE-extension for the GUI of the frame-based
		recording engine.
		This is necessary as a workaround for a bug in some X-servers,
		such as in Ubuntu-7.10 when visual desktop effects are enabled.
		
		the opposite option is --use-shape. 
		--no-shape is the default

	--use-shape
		enable the use of the SHAPE-extension for the GUI of the frame-based
		recording engine.
		Warning: This can trigger a bug in some X-Servers which causes 
		the X-Server to crash.
		
	--autohide
		When in opengl-hw mode, then hide the GUI while recording.
		In this case, you can stop the recording by pressing the Hotkey Ctrl-Alt-S
		This option enables all hotkeys.

	--hide-frame
		When in opengl-hw mode, then hide the red frame.
		This can be useful when the coordinates of the recordinhg area are specified
		by commandline.

	--hide-toolbar
		When in opengl-hw mode, then hide the toolbar.
		This can be useful when using hotkeys or autostart or tty-hotkeys.
		
	--hide-gui
		When in opengl-hw mode, then hide the GUI.
		This can be useful when the coordinates of the frame are specified
		by commandline and when using hotkeys or autostart or tty-hotkeys.		

	--autostart
		Automatically start recording as soon as DemoRecorder is started.
		Currently, this works only in the opengl-hw mode.

	--file-dir directory
		The given directory will be used as the default directory 
		for Load and Save dialogs.
		( this overrides the FILE_DIR setting in ~/.DemoRecorder/preferences )
		
	--load demorecorder-video
		The given demorecorder-video is loaded for playback in the GUI.
		
	--play demorecorder-video
		The given demorecorder-video is loaded for playback in the GUI 
		and playback is started automatically.

	--enable-hotkeys
		When in opengl-hw mode, then enable the following hotkeys:
			Ctrl-Alt-R or F9: start recording ( or resume after pause )
			Ctrl-Alt-P or F9: pause recording ( or resume after pause )
			Ctrl-Alt-S  or F10: stop recording
			Ctrl-Alt-Q: quit DemoRecorder
		The hotkey work on the display which you are recording.

	--disable-hotkeys
		Disable the hotkeys which have been 
		switched on by --enable-hotkeys or --autohide

	--enable-start-hotkey
	--disable-start-hotkey
		only in opengl-hw mode:
		Enable or disable the start-hotkey(s) 
		( default keybinding: Ctrl-Alt-R )

	--enable-stop-hotkey
	--disable-stop-hotkey
		only in opengl-hw mode:
		Enable or disable the stop-hotkey(s) 
		( default keybindings: Ctrl-Alt-S and F10 )

	--enable-start-stop-hotkey
	--disable-start-stop-hotkey
		only in opengl-hw mode:
		Enable or disable the start-stop-hotkey(s) 
		( there is no default keybinding )

	--enable-start-pause-hotkey
	--disable-start-pause-hotkey
		only in opengl-hw mode:
		Enable or disable the start-pause-hotkey(s) 
		( default keybinding: F9 )

	--enable-pause-hotkey
	--disable-pause-hotkey
		only in opengl-hw mode:
		Enable or disable the pause-hotkey(s) 
		( default keybinding: Ctrl-Alt-P )

	--enable-quit-hotkey
	--disable-quit-hotkey
		only in opengl-hw mode:
		Enable or disable the quit-hotkey(s) 
		( default keybinding: Ctrl-Alt-Q )

	--enable-tty-hotkeys
		When in opengl-hw mode, then enable to use the ENTER-key 
		in the tty which you have started demorec
		for starting and stopping the recording,
		or using commands in the tty which can trigger different actions.
		(see the comments for the options starting with --tty-command- 
		for details)
		Each command has to be committed with the ENTER-key.	
		
	--tty-command-quit
		tty-command which quits DemoRecorder.
	
		default: "quit"

	--tty-command-start-rec
		tty-command which starts recording.

		default: "rec"
	
	--tty-command-pause-rec
		tty-command which pauses recording.

		default: "pause"
	
	--tty-command-resume-rec
		tty-command which resumes recording after a pause.

		default: "resume"

	--tty-command-stop-rec
		tty-command which stops recording, i.e. finishes the video.

		default: "stop"
		
	--display-fps-in-tty
		show the current fps-rate in the tty
			
	--dont-display-fps-in-tty
		don't show the current fps-rate in the tty
		(this is the default behavior)
		
	--auto-quit
		Quit DemoRecorder after finishing the recording.
		( Only available in opengl-hw mode )	
	
	--xgl
		start Xgl in demorecorder and 
		then start the desktop on top of xgl.
		See http://DemoRecorder.com/howto/xgl for more info

	--xgl-prefix prefix
		Installation-prefix of Xgl, 
		e.g. use "/usr/X11" if Xgl is in "/usr/X11/bin/Xgl"
		default is "/opt/Xgl"

	--animation
		Optimize for recording animated content.
		
		This affects recording performance 
		and smoothnees of animations during recording.
		It may increase loading time of videos in the preview-playback.

	--opengl
		Optimize the frameless engine for recording opengl apps.
		(opengl is still run through software emulation, 
		so don't expect top speed)

		This affects recording performance 
		and smoothnees of animations during recording.
		It may increase loading time of videos in the preview-playback.
		
		For OpenGL you may also want to try the frame-based 
		recording engine which supports hardware-accelerated
		OpenGL.
		Please use the option --frame-based or --opengl-hw for using that engine.
		
	--minTimeBetweenMotionEventsMsec delay
		wait at least "delay" Milliseconds between generation mouse motion events for the clients.
		This is useful for clients which do not do event compression and which
		get overloaded that way.
		
	--minTimeBetweenXINPUTMotionEventsMsec delay
		wait at least "delay" Milliseconds between generation XINPUT motion events for the clients.
		This is useful for clients which do not do event compression and which
		get overloaded that way.
		XINPUT motion events are, e.g., generated by tablets.
		
	-display display
		Set the current display 
		(overrides the contents of the env-var DISPLAY)
		
	--version
		show current DemoRecorder version 
		( only works for official versions,
		prereleases may show wrong version numbers. )
		
	--licenseinfo
		show currently installed licenses and their state
	
eof
	usage_option_licensepath
	usage_option_help
}

usage_option_mpeg2_target() {
	cat << 'eof'
	--target
		Select predefined target for mpeg2.
		
		Supported values are:
			pal-dvd
			ntsc-dvd

		Default: no target selected
		
eof
}

usage_option_dv_target() {
	cat << 'eof'
	--target
		Select target system for dv.
		
		Supported values are:
			pal
			ntsc

		Default: pal
		
eof
}
