#!/bin/sh

replaceCC=false
newCC=gcc

#Parse commandline
while [ "$1" != "" ] ; do
	case $1 in
		CC=*)
			newCC=` echo $1 | sed -e 's/^CC=//' `
			replaceCC=true
			shift	
		;;		
		*)
			echo illegal commandline arg \"$1\"
			exit 1
		;;
	esac
done

if [ -f api/examples/xlib/testDispRecCtrlExt.c ] ; then
	find api -type d -print | xargs chmod a+wX api
	chmod a+wX .
	tar cvzf DemoRecorder-Api-Src.tgz --exclude='*.a' --exclude='*.o' api
	if [ "$replaceCC" = "true" ] ; then
		tempdir=/var/tmp/create-api-src-tarball-tmp.$$
		mkdir $tempdir
		cat DemoRecorder-Api-Src.tgz | ( cd $tempdir ; tar xvpzf - )
		#patch makefiles
		find $tempdir/api -name Makefile -print -exec sed -i -e "s/^CC=gcc/CC=$newCC/" {} \;
		#recreate the tar archive
		( cd $tempdir ; tar cvzf - . ) > DemoRecorder-Api-Src.tgz
		#clean up
		echo rm -rf $tempdir
	fi 
else
	echo "no DemoRecorder api-dir found. Please start this script in the DemoRecorder install dir"
fi

