#!/bin/sh

#Sound-encoder for DV

DEMOREC_DIR=/opt/DemoRecorder
export LD_LIBRARY_PATH="$DEMOREC_DIR/lib:$DEMOREC_DIR/3rdparty/lib:$LD_LIBRARY_PATH"

echo DV-soundEncoder.sh: commandline: $*

soundinputpipe=""
soundoutputpipe=""
videopipe=""
output_target_opt=""
output_config_opts=""
nosound=""
resampleFreq_Hz=48000

while [ "$1" != "" ] ; do
	case "$1" in
		--sound-input-pipe)
			soundinputpipe=$2
			shift
			shift
		;;
		--sound-output-pipe)
			soundoutputpipe=$2
			shift
			shift
		;;
		--input-sound-samples-per-second)
			inputSoundSamplesPerSecond=$2
			shift ; shift
		;;
		--input-sound-channels)
			inputSoundChannels=$2
			shift ; shift
		;;
		--input-bits-per-sound-sample)
			inputBitsPerSoundSample=$2
			shift ; shift
		;;
		--input-sound-signedness)
			inputSoundSignedness=$2
			shift ; shift
		;;
		--input-sound-endianness)
			inputSoundEndianness=$2
			shift ; shift
		;;
		--input-sound-scale)
			inputSoundScale=$2
			shift ; shift
		;;
		--input-sound-compression-method)
			inputSoundCompressionMethod=$2
			shift ; shift
		;;
		--output-bitrate)
		 	output_config_opts="$output_config_opts --abr $2"
			shift ; shift
		;;
		--output-max-bitrate)
		 	output_config_opts="$output_config_opts -B $2"
			shift ; shift
		;;
		--output-min-bitrate)
		 	output_config_opts="$output_config_opts -b $2"
			shift ; shift
		;;
		--output-sound-bitrate)
		 	output_config_opts="$output_config_opts --abr $2"
			shift ; shift
		;;
		--output-sound-samples-per-second)
			resampleFreq_Hz="$2"
			shift ; shift
		;;
		--output-file)
		 	outputFile="$2"
			shift ; shift
		;;
		--no-sound)
		 	nosound="nosound"
			shift
		;;
		#special opts for mpeg
		--special-mpeg-target)
			output_target_opt="$output_target_opt -target $2"
			shift ; shift
		;;
		*)
			echo "soundEncoder.sh: Unrecognized arg \"$1\""
			shift
	esac
done

#echo "videopipe=$videopipe"
#echo "soundpipe=$soundpipe"
#echo "inputFramesPerSecond=$inputFramesPerSecond"
#echo "inputResolution=$inputResolution"
#echo "output_target_opt=$output_target_opt"
#echo "output_config_opts=$output_config_opts"
#echo "outputFile=$outputFile"

#( sed -e 's/^/videopipe: /' <$videopipe ) &
#( sed -e 's/^/soundpipe: /' <$soundpipe ) &
#wait

#cat $soundpipe >/tmp/sound.raw

#output_config_opts="$output_config_opts -acodec mp2 -f mp2"
	#echo "encoder.sh with sound"
	if [ \
		"$inputBitsPerSoundSample" = "16" \
		-a \
		"$inputSoundSignedness" = "signed" \
	] ; then
		if [ "$inputSoundEndianness" = "little" ] ; then
			soundFormat="-s -w"
		else
			soundFormat="-s -w -x"
		fi
	elif [ \
		"$inputBitsPerSoundSample" = "8" \
		-a \
		"$inputSoundSignedness" = "signed" \
	] ; then
		soundFormat="-s -b"
	else
		#use sox or a similar program to convert
		#TODO
		soundFormat="-s -w"
	fi 

#	echo $DEMOREC_DIR/3rdparty/bin/ffmpeg \
#		-ar $inputSoundSamplesPerSecond -ac $inputSoundChannels -f $soundFormat -i $soundinputpipe \
#		$output_target_opt $output_config_opts $soundoutputpipe

	tmpsound=/tmp/drSoundEncoder.$$.mp3
	
#	$DEMOREC_DIR/3rdparty/bin/ffmpeg \
#		-ar $inputSoundSamplesPerSecond -ac $inputSoundChannels -f $soundFormat -i $soundinputpipe \
#		$output_target_opt $output_config_opts $tmpsound

#cat $soundinputpipe >/var/tmp/test-soundinput

#exit 0

echo	sox \
		-r $inputSoundSamplesPerSecond $soundFormat -c $inputSoundChannels $soundinputpipe \
		-r $resampleFreq_Hz -s -w -c 2 $soundoutputpipe
	
	sox \
		-t raw -r $inputSoundSamplesPerSecond $soundFormat -c $inputSoundChannels $soundinputpipe  \
		-t raw -r $resampleFreq_Hz -s -w -c 2 $soundoutputpipe
	
#endif
#( cat $soundpipe >/tmp/sound.raw ) &
#ffmpeg -an -s 720x576 -vcodec ppm -f image2pipe -i $videopipe -target dvd as.mp2

