#!/bin/sh

DEMOREC_DIR=/opt/DemoRecorder
export LD_LIBRARY_PATH="$DEMOREC_DIR/lib:$DEMOREC_DIR/3rdparty/lib:$LD_LIBRARY_PATH"

echo FLV-soundEncoder.sh: commandline: $*

soundinputpipe=""
soundoutputpipe=""
videopipe=""
output_target_opt=""
output_config_opts=""
nosound=""
resampleFreq_kHz=22.05

while [ "$1" != "" ] ; do
	case "$1" in
		--sound-input-pipe)
			soundinputpipe=$2
			shift
			shift
		;;
		--sound-output-pipe)
			soundoutputpipe=$2
			shift
			shift
		;;
		--input-sound-samples-per-second)
			inputSoundSamplesPerSecond=$2
			shift ; shift
		;;
		--input-sound-channels)
			inputSoundChannels=$2
			shift ; shift
		;;
		--input-bits-per-sound-sample)
			inputBitsPerSoundSample=$2
			shift ; shift
		;;
		--input-sound-signedness)
			inputSoundSignedness=$2
			shift ; shift
		;;
		--input-sound-endianness)
			inputSoundEndianness=$2
			shift ; shift
		;;
		--input-sound-scale)
			inputSoundScale=$2
			shift ; shift
		;;
		--input-sound-compression-method)
			inputSoundCompressionMethod=$2
			shift ; shift
		;;
		--output-bitrate)
		 	output_config_opts="$output_config_opts --abr $2"
			shift ; shift
		;;
		--output-max-bitrate)
		 	output_config_opts="$output_config_opts -B $2"
			shift ; shift
		;;
		--output-min-bitrate)
		 	output_config_opts="$output_config_opts -b $2"
			shift ; shift
		;;
		--output-sound-bitrate)
		 	output_config_opts="$output_config_opts --abr $2"
			shift ; shift
		;;
		--output-sound-samples-per-second)
			resampleFreq_kHz=`echo "$2" | sed -e 's/\(...\)$/.\1/' ` # $2 / 1000
			shift ; shift
		;;
		--output-file)
		 	outputFile="$2"
			shift ; shift
		;;
		--no-sound)
		 	nosound="nosound"
			shift
		;;
		#special opts for mpeg
		--special-mpeg-target)
			output_target_opt="$output_target_opt -target $2"
			shift ; shift
		;;
		*)
			echo "soundEncoder.sh: Unrecognized arg \"$1\""
			shift
	esac
done

#echo "videopipe=$videopipe"
#echo "soundpipe=$soundpipe"
#echo "inputFramesPerSecond=$inputFramesPerSecond"
#echo "inputResolution=$inputResolution"
#echo "output_target_opt=$output_target_opt"
#echo "output_config_opts=$output_config_opts"
#echo "outputFile=$outputFile"

#( sed -e 's/^/videopipe: /' <$videopipe ) &
#( sed -e 's/^/soundpipe: /' <$soundpipe ) &
#wait

#cat $soundpipe >/tmp/sound.raw

#output_config_opts="$output_config_opts -acodec mp2 -f mp2"
	#echo "encoder.sh with sound"
	if [ \
		"$inputBitsPerSoundSample" = "16" \
		-a \
		"$inputSoundSignedness" = "signed" \
	] ; then
		if [ "$inputSoundEndianness" = "little" ] ; then
			soundFormat="s16le"
		else
			soundFormat="s16be"
		fi
	elif [ \
		"$inputBitsPerSoundSample" = "8" \
		-a \
		"$inputSoundSignedness" = "signed" \
	] ; then
		soundFormat="s8"
	else
		#use sox or a similar program to convert
		soundFormat="s16le"
	fi 

#	echo $DEMOREC_DIR/3rdparty/bin/ffmpeg \
#		-ar $inputSoundSamplesPerSecond -ac $inputSoundChannels -f $soundFormat -i $soundinputpipe \
#		$output_target_opt $output_config_opts $soundoutputpipe

	tmpsound=/tmp/drSoundEncoder.$$.mp3
	
#	$DEMOREC_DIR/3rdparty/bin/ffmpeg \
#		-ar $inputSoundSamplesPerSecond -ac $inputSoundChannels -f $soundFormat -i $soundinputpipe \
#		$output_target_opt $output_config_opts $tmpsound

	inputSoundSamplesPerMilliSecond=`echo $inputSoundSamplesPerSecond | sed -e 's/\([0-9][0-9][0-9]\)$/.\1/' ` 
	
	if [ "$inputSoundChannels" = "1" ] ; then
		mode=m
	elif [ "$inputSoundChannels" = "2" ] ; then
		 mode=j
	else
		echo "soundEncoder.sh: unsupported number of channels $inputSoundChannels, assuming mono"
		mode=m
	fi	

	echo $DEMOREC_DIR/3rdparty/bin/lame -r \
		-s  $inputSoundSamplesPerMilliSecond \
		--bitwidth $inputBitsPerSoundSample \
		--resample $resampleFreq_kHz \
		-m $mode \
		--silent \
		$output_config_opts \
		-t \
		$soundinputpipe  $tmpsound 
		
	$DEMOREC_DIR/3rdparty/bin/lame -r \
		-s  $inputSoundSamplesPerMilliSecond \
		--bitwidth $inputBitsPerSoundSample \
		--resample $resampleFreq_kHz \
		-m $mode \
		--silent \
		$output_config_opts \
		-t \
		$soundinputpipe  $tmpsound 
		
	echo "tmpsound=$tmpsound"
		
	cat $tmpsound >$soundoutputpipe
	
	rm $tmpsound
	
#endif
#( cat $soundpipe >/tmp/sound.raw ) &
#ffmpeg -an -s 720x576 -vcodec ppm -f image2pipe -i $videopipe -target dvd as.mp2

